	list p=16f883
	#include "p16f883.inc"
	__config	_CONFIG1, _HS_OSC & _WDT_OFF & _PWRTE_ON & _MCLRE_OFF & _CP_OFF & _CPD_OFF & _BOR_ON & _IESO_OFF & _FCMEN_OFF & _LVP_OFF & _DEBUG_OFF
	__config	_CONFIG2, _BOR40V & _WRT_OFF


PORTA_TX	equ	0
PORTA_RX	equ	5


work0	equ	0x70
work1	equ	0x71
work2	equ	0x72

val_ra	equ	0x73

rxdata	equ	0x74
txdata	equ	0x75

mode	equ	0x76
MODE_CHANGE	equ	0
MODE_CHANGEBUF	equ	1
MODE_FULL	equ	2

len	equ	0x78
addrh	equ	0x79
addrl	equ	0x7a
sum	equ	0x7b

currentbuf	equ	0x7c
currentaddrh	equ	0x7d
currentaddrl	equ	0x7e

membuf0	equ	0x20		; - 0x41 : buf0 (address(2) + data(32))
membuf1	equ	0x42		; - 0x63 : buf1

membuf2	equ	0xa0		; - 0xc1 : buf2
membuf3	equ	0xc2		; - 0xe3 : buf3


	org	0
	goto	init
	goto	0x201		; not use
	goto	0x202		; not use
	goto	0x203		; not use
	goto	0x204		; interrupt vector


cmdtable
	addwf	PCL, 1
	retlw	0x47			; 'G'
	retlw	0x45			; 'E'
	retlw	0x54			; 'T'
	retlw	0x20			; ' '
	retlw	0x2f			; '/'
	retlw	0x70			; 'p'
	retlw	0x69			; 'i'
	retlw	0x63			; 'c'
	retlw	0x2f			; '/'
	retlw	0x74			; 't'
	retlw	0x6d			; 'm'
	retlw	0x70			; 'p'
	retlw	0x2e			; '.'
	retlw	0x48			; 'H'
	retlw	0x45			; 'E'
	retlw	0x58			; 'X'
	retlw	0x20			; ' '
	retlw	0x48			; 'H'
	retlw	0x54			; 'T'
	retlw	0x54			; 'T'
	retlw	0x50			; 'P'
	retlw	0x2f			; '/'
	retlw	0x31			; '1'
	retlw	0x2e			; '.'
	retlw	0x30			; '0'
	retlw	0xd
	retlw	0xa
	retlw	0xd
	retlw	0xa
	retlw	0


wait1ms
	clrf	work0
	call	wait1ms_loop
	call	wait1ms_loop
	call	wait1ms_loop
wait1ms_loop
	nop
	nop
	decfsz	work0, 1
	goto	wait1ms_loop
	retlw	0

wait50ms
	movlw	0x32
	movwf	work1
	goto	wait100ms_loop
wait200ms
	movlw	0xc8
	movwf	work1
	goto	wait100ms_loop
wait100ms
	movlw	0x64
	movwf	work1
wait100ms_loop
	call	wait1ms
	decfsz	work1, 1
	goto	wait100ms_loop
	retlw	0

wait1s
	call	wait200ms
	call	wait200ms
	call	wait200ms
	call	wait200ms
	goto	wait200ms


waitrx
	movlw	0x3f			; (65clk - 2)
	subwf	TMR0, 1
waitrx0
	btfsc	TMR0, 7
	goto	waitrx0
	
	retlw	0


recvrs
	call	waitrx			; skip stop-bit
recvrs0
	btfsc	PORTA, PORTA_RX		; wait start-bit
	goto	recvrs0
	
	movlw	0x1e			; 1/2 bit
	movwf	TMR0
	call	waitrx
	
	btfsc	PORTA, PORTA_RX		; check start-bit
	goto	recvrs0
	
	clrf	rxdata
	
	call	waitrx
	btfsc	PORTA, PORTA_RX
	bsf	rxdata, 0
	
	call	waitrx
	btfsc	PORTA, PORTA_RX
	bsf	rxdata, 1
	
	call	waitrx
	btfsc	PORTA, PORTA_RX
	bsf	rxdata, 2
	
	call	waitrx
	btfsc	PORTA, PORTA_RX
	bsf	rxdata, 3
	
	call	waitrx
	btfsc	PORTA, PORTA_RX
	bsf	rxdata, 4
	
	call	waitrx
	btfsc	PORTA, PORTA_RX
	bsf	rxdata, 5
	
	call	waitrx
	btfsc	PORTA, PORTA_RX
	bsf	rxdata, 6
	
	call	waitrx
	btfsc	PORTA, PORTA_RX
	bsf	rxdata, 7
	
	retlw	0


sendrs
	movwf	txdata
	call	waitrx
	bcf	val_ra, PORTA_TX
	movf	val_ra, 0
	movwf	PORTA
	
	movlw	8
	movwf	work0
sendrs0
	call	waitrx
	bcf	val_ra, PORTA_TX
	rrf	txdata, 1
	btfsc	STATUS, C
	bsf	val_ra, PORTA_TX
	movf	val_ra, 0
	movwf	PORTA
	
	decfsz	work0, 1
	goto	sendrs0
	
	call	waitrx
	bsf	val_ra, PORTA_TX
	movf	val_ra, 0
	movwf	PORTA
	
	call	waitrx
	retlw	0


recvhex
	call	recvrs
	movf	rxdata, 0
	btfsc	rxdata, 6
	addlw	9			; 0x41 -> 0x4a
	andlw	0xf
	movwf	work0
	swapf	work0, 1
	
	call	recvrs
	movf	rxdata, 0
	btfsc	rxdata, 6
	addlw	9			; 0x41 -> 0x4a
	andlw	0xf
	iorwf	work0, 0
	movwf	rxdata
	addwf	sum, 1
	retlw	0


disperror
	iorlw	0x80
	xorlw	0xff
	movwf	PORTB
	
	bsf	STATUS, RP0
	movlw	0			; rb: OOOOOOOO
	movwf	PORTB
	bcf	STATUS, RP0
disperror0
	goto	disperror0


setaddr
	btfsc	mode, MODE_FULL
	retlw	0
	
	movf	currentaddrh, 0
	xorwf	addrh, 0
	btfss	STATUS, Z
	goto	setaddr_nextbuf
	
	movf	currentaddrl, 0
	xorwf	addrl, 0
	andlw	0xe0
	btfss	STATUS, Z
	goto	setaddr_nextbuf
	
	goto	setaddr1
	
setaddr_nextbuf
	btfss	mode, MODE_CHANGEBUF
	goto	setaddr_clrbuf
	
	movlw	membuf1 - membuf0
	addwf	currentbuf, 1
	btfss	currentbuf, 2		; 0x20 -> 0x42 -> 0x64
	goto	setaddr_clrbuf
	
	btfsc	currentbuf, 7
	goto	setaddr_full
	
	movlw	membuf2
	movwf	currentbuf
	
setaddr_clrbuf
	bcf	mode, MODE_CHANGEBUF
	movf	currentbuf, 0
	addlw	2
	movwf	FSR
	movlw	8
	movwf	work0
	movlw	0xff
setaddr_clrbuf0
	movwf	INDF
	incf	FSR, 1
	movwf	INDF
	incf	FSR, 1
	movwf	INDF
	incf	FSR, 1
	movwf	INDF
	incf	FSR, 1
	decfsz	work0, 1
	goto	setaddr_clrbuf0
	
setaddr1
	movf	currentbuf, 0
	movwf	FSR
	
	movf	addrh, 0
	movwf	currentaddrh
	movwf	INDF
	incf	FSR, 1
	
	movf	addrl, 0
	andlw	0xe0
	movwf	currentaddrl
	movwf	INDF
	incf	FSR, 1
	
	movf	addrl, 0
	andlw	0x1f
	addwf	FSR, 1
	
	
	bcf	STATUS, C
	rrf	addrh, 0
	bsf	STATUS, RP1
	movwf	EEADRH & 0x7f
	bcf	STATUS, RP1
	
	rrf	addrl, 0
	bsf	STATUS, RP1
	movwf	EEADR & 0x7f
	
	bsf	STATUS, RP0
	bsf	EECON1 & 0x7f, EEPGD
	bsf	EECON1 & 0x7f, RD
	nop
	nop
	bcf	STATUS, RP0
	bcf	STATUS, RP1
	
	retlw	0
	
setaddr_full
	bsf	mode, MODE_FULL
	retlw	0


setdatal
	btfsc	mode, MODE_FULL
	retlw	0
	
	movwf	INDF
	incf	FSR, 1
	
	bsf	STATUS, RP1
	xorwf	EEDAT & 0x7f, 0
	bcf	STATUS, RP1
	
	btfss	STATUS, Z
	bsf	mode, MODE_CHANGEBUF
	btfss	STATUS, Z
	bsf	mode, MODE_CHANGE
	
	retlw	0


setdatah
	btfsc	mode, MODE_FULL
	retlw	0
	
	movwf	INDF
	incf	FSR, 1
	
	bsf	STATUS, RP1
	xorwf	EEDATH & 0x7f, 0
	bcf	STATUS, RP1
	
	btfss	STATUS, Z
	bsf	mode, MODE_CHANGEBUF
	btfss	STATUS, Z
	bsf	mode, MODE_CHANGE
	
	bsf	STATUS, RP1
	incf	EEADR & 0x7f, 1
	bsf	STATUS, RP0
	bsf	EECON1 & 0x7f, EEPGD
	bsf	EECON1 & 0x7f, RD
	nop
	nop
	bcf	STATUS, RP0
	bcf	STATUS, RP1
	
	retlw	0


writebuf
	movwf	FSR
	movf	INDF, 0
	movwf	addrh
	incf	FSR, 1
	movf	INDF, 0
	movwf	addrl
	incf	FSR, 1
	
	bcf	STATUS, C
	rrf	addrh, 0
	bsf	STATUS, RP1
	movwf	EEADRH & 0x7f
	bcf	STATUS, RP1
	rrf	addrl, 0
	bsf	STATUS, RP1
	movwf	EEADR & 0x7f
	bcf	STATUS, RP1
	
	movlw	0x10
	movwf	work0
writebuf0
	bsf	STATUS, RP1
	movf	INDF, 0
	movwf	EEDAT & 0x7f
	incf	FSR, 1
	movf	INDF, 0
	movwf	EEDATH & 0x7f
	incf	FSR, 1
	
	bsf	STATUS, RP0
	bsf	EECON1 & 0x7f, EEPGD
	bsf	EECON1 & 0x7f, WREN
	movlw	0x55
	movwf	EECON2 & 0x7f
	movlw	0xaa
	movwf	EECON2 & 0x7f
	bsf	EECON1 & 0x7f, WR
	nop
	nop
	bcf	EECON1 & 0x7f, WREN
	bcf	STATUS, RP0
	
	incf	EEADR & 0x7f, 1
	
	bcf	STATUS, RP1
	
	decfsz	work0, 1
	goto	writebuf0
	
	retlw	0


initreg
	clrf	STATUS			; RP0
	bsf	STATUS, RP0
	
	movlw	0xfe			; ra: IIIIIIIO
	movwf	PORTA
;	movlw	0			; rb: OOOOOOOO
	movlw	0xff			; rb: IIIIIIII
	movwf	PORTB
;	movlw	0			; rc: OOOOOOOO
	movlw	0xff			; rc: IIIIIIII
	movwf	PORTC
	
	movlw	2
	movwf	OPTION_REG & 0x7f	; TMR0: 0.625MHz
	
	bsf	STATUS, RP1
	
	movlw	0xee			; AAADAAAD
	movwf	ANSEL & 0x7f
	movlw	0xff			; AAAAAAAA
	movwf	ANSELH & 0x7f
	
	bcf	STATUS, RP1
	bcf	STATUS, RP0
	
	retlw	0


init
	clrf	STATUS
	movlw	0x01
	movwf	val_ra
	movwf	PORTA
	movlw	0xff
	movwf	PORTB
	clrf	PORTC
	
	call	initreg
	
	movlw	0x14
	movwf	work2
init0
	btfsc	PORTA, PORTA_RX
	goto	main2
	call	wait50ms
	
	decfsz	work2, 1
	goto	init0
	
	call	wait1s
	call	wait1s
	call	wait1s
	call	wait1s
	call	wait1s
	
	call	wait1s
	call	wait1s
	call	wait1s
	call	wait1s
	call	wait1s
main
;	movlw	0xbf
;	movwf	PORTB
	
	movlw	membuf0
	movwf	currentbuf
	clrf	mode
	clrf	currentaddrh
	clrf	currentaddrl
	
	call	waitrx
	call	waitrx
	call	waitrx
	
	clrf	work2
	movf	work2, 0
	call	cmdtable
main0
	call	sendrs
	
	incf	work2, 1
	movf	work2, 0
	call	cmdtable
	iorlw	0
	btfss	STATUS, Z
	goto	main0
	
waitresp
	call	recvrs
	movf	rxdata, 0
	xorlw	0xd
	btfss	STATUS, Z
	goto	waitresp
	
	call	recvrs
	movf	rxdata, 0
	xorlw	0xa
	btfss	STATUS, Z
	goto	waitresp
	
	call	recvrs
	movf	rxdata, 0
	xorlw	0xd
	btfss	STATUS, Z
	goto	waitresp
	
	call	recvrs
	movf	rxdata, 0
	xorlw	0xa
	btfss	STATUS, Z
	goto	waitresp
	
;	movlw	0xff
;	movwf	PORTB
recvline
	call	recvrs
	movf	rxdata, 0
	xorlw	0x3a			; ":"
	btfss	STATUS, Z
	goto	recvline
	
	clrf	sum
recvline_len
	call	recvhex
	movf	rxdata, 0
	movwf	len
	addlw	0xef
	
	movlw	0x10			; error: len > 0x10
	btfsc	STATUS, C
	goto	disperror
	
	movlw	0x11			; error: odd len
	btfsc	len, 0
	goto	disperror
recvline_addr
	call	recvhex
	movf	rxdata, 0
	movwf	addrh
	
	andlw	0xf0
	movlw	0x20			; error: addr >= 0x800
	btfss	STATUS, Z
	goto	disperror
	
	call	recvhex
	movf	rxdata, 0
	movwf	addrl
	
	andlw	1
	movlw	0x21			; error: odd addr
	btfss	STATUS, Z
	goto	disperror
	
	movf	addrl, 0
	andlw	0xf
	addwf	len, 0
	addlw	0xef
	
	movlw	0x22			; error: miss alignment
	btfsc	STATUS, C
	goto	disperror
	
recvline_type
	call	recvhex
	movf	rxdata, 0
	
	btfsc	STATUS, Z
	goto	recvline_data
	
	xorlw	1
	btfsc	STATUS, Z
	goto	flushdata
	
	goto	recvline
	
recvline_data
	movf	addrh, 0
	andlw	0xfc
	movlw	0x23			; error: addr < 0x200
	btfsc	STATUS, Z
	goto	disperror
	
	call	setaddr
	
recvline_data0
	call	recvhex
	movf	rxdata, 0
	call	setdatal
	
	call	recvhex
	movf	rxdata, 0
	call	setdatah
	
	decf	len, 1
	decfsz	len, 1
	goto	recvline_data0
	
	call	recvhex
	movf	sum, 0
	
	movlw	0x40			; error: check sum error
	btfss	STATUS, Z
	goto	disperror
	
	goto	recvline
	
flushdata
	btfss	mode, MODE_CHANGE
	goto	main2
	
	btfsc	mode, MODE_CHANGEBUF
	incf	currentbuf, 1
	
	movf	currentbuf, 0
	sublw	membuf1			; membuf1 + (-currentbuf)
	btfsc	STATUS, C
	goto	flushdata0
	
	movf	currentbuf, 0
	sublw	membuf2			; membuf2 + (-currentbuf)
	btfsc	STATUS, C
	goto	flushdata1
	
	movf	currentbuf, 0
	sublw	membuf3			; membuf3 + (-currentbuf)
	btfsc	STATUS, C
	goto	flushdata2
	
flushdata3
;	movlw	0xf7
;	movwf	PORTB
;	call	wait100ms
	
	movlw	membuf3
	call	writebuf
flushdata2
;	movlw	0xfb
;	movwf	PORTB
;	call	wait100ms
	
	movlw	membuf2
	call	writebuf
flushdata1
;	movlw	0xfd
;	movwf	PORTB
;	call	wait100ms
	
	movlw	membuf1
	call	writebuf
flushdata0
;	movlw	0xfe
;	movwf	PORTB
;	call	wait100ms
	
	movlw	membuf0
	call	writebuf
	
	goto	main


	org	0x200
main2
	movlw	0xff
	goto	disperror


	end
